#include "aboutwindow.h"
#include <QtGui>

AboutWindow::AboutWindow(QWidget * parent, Qt::WindowFlags f) : QFrame(parent, f)
{
	QPushButton * buttonClose = new QPushButton(tr("Close"));

	QTextBrowser * textBrowser = new QTextBrowser;
	QFile textFile(":/about.htm");
	textFile.open(QIODevice::ReadOnly | QIODevice::Text);
	QTextStream textStream(&textFile);
	QString text = textStream.readAll();
	textBrowser->setAcceptRichText(true);
	textBrowser->setText(text);
	textBrowser->setReadOnly(true);

	connect(buttonClose, SIGNAL(clicked()), this, SLOT(close()));

	QVBoxLayout * layoutMain = new QVBoxLayout;
	layoutMain->addWidget(textBrowser);
	layoutMain->addWidget(buttonClose);

	setLayout(layoutMain);

	QRect screen = QApplication::desktop()->screenGeometry();
	int width = 600;
	int height = 300;
	int x = (screen.width()-width) / 2;
	int y = (screen.height()-height) / 2;
	setGeometry(x, y, width, height);
//	setWindowModality(Qt::ApplicationModal);
	setFocusPolicy(Qt::StrongFocus);

}

void AboutWindow::keyPressEvent(QKeyEvent * event)
{
	switch(event->key())
	{
		case Qt::Key_Escape: close(); break;
	}
}

