#ifndef DBG_H
#define DBG_H

#include <iostream>
#include <iomanip>
#include <cassert>

#ifndef DEBUG
	#define DEBUG
#endif

#ifdef QT_NO_DEBUG
	#undef DEBUG
#endif

#ifdef DEBUG
	#define DBG(str) std::cerr << std::dec << std::setprecision(13) << std::setw(20) << std::left << __FILE__ << ':' << std::setw(5) << std::right << __LINE__ << "> " << str << std::endl << std::flush
#else
	#define DBG(str)
#endif

#define COUT(str) std::cout << __FILE__ << ':' << std::setw(5) << __LINE__ << "> " << str << std::endl << std::flush
#define CERR(str) std::cerr << __FILE__ << ':' << std::setw(5) << __LINE__ << "> " << str << std::endl << std::flush
#define EXIT() CERR("EXIT...aborting application"); abort();
#define CINGET() CERR("Press ENTER to continue..."); std::cin.get();

#endif
