#ifndef KEYWORDSFILTER_H
#define KEYWORDSFILTER_H

#include <QWidget>
#include <QModelIndex>
#include "mlfmodeldata.h"
#include "dbg.h"
#include "mlfsortingthread.h"

class QListView;
class QModelIndex;
class QStandardItemModel;
//class QMap;

class KeywordsFilter : public QWidget
{
	Q_OBJECT

	public:
		KeywordsFilter(QWidget* parent = NULL);
//		void SetMlfModelData(const MlfModelData::Data* data);
		const MlfSortingThread::SelectedKeywordsMap* GetKeywordsMap();
		void SetSelectedKeywordsMap(MlfSortingThread::SelectedKeywordsMap * map) { mpMap = map; }

	public slots:
		void SelectActiveKeyword();
		void DeselectActiveKeyword();
		void SelectAllKeywords();
		void DeselectAllKeywords();
		void SelectKeyword(int row);
		void DeselectKeyword(int row);
		void ListDeselectedClicked(const QModelIndex & index);
		void ListSelectedClicked(const QModelIndex & index);
		void OkClicked();
		void CancelClicked();
		void show();

	protected:
		void keyPressEvent(QKeyEvent * event);

	signals:
		void FilterChanged();

	private:
		QListView *			mpListKeywordsDeselected;
		QListView *			mpListKeywordsSelected;

		QStandardItemModel *	mpModelDeselected;
		QStandardItemModel *	mpModelSelected;

		MlfSortingThread::SelectedKeywordsMap * mpMap;

		int		mActiveRowSelected;
		int		mActiveRowDeselected;
};

#endif

