#include "mediaplayer.h"
#include <QtGui>


MediaPlayer::MediaPlayer(QWidget* parent) : QFrame(parent)
{
/*
	// MEDIA
	mpAudioOutput = new Phonon::AudioOutput(Phonon::MusicCategory, this);
    mpMediaObject = new Phonon::MediaObject(this);
    Phonon::createPath(mpMediaObject, mpAudioOutput);
	mpMediaObject->setTickInterval(100);

	connect(mpMediaObject, SIGNAL(seekableChanged(bool)), this, SLOT(SeekableChanged(bool)));
	connect(mpMediaObject, SIGNAL(stateChanged(Phonon::State, Phonon::State)), this, SLOT(StateChanged(Phonon::State, Phonon::State)));
	connect(mpMediaObject, SIGNAL(tick(qint64)), this, SLOT(Tick(qint64)));
	connect(mpMediaObject, SIGNAL(finished()), mpMediaObject, SLOT(stop()));
*/
	// VISUAL
	setAutoFillBackground(true);

	mpSeekSlider = new QSlider(Qt::Horizontal);
	mpButtonPlayDetection = new QPushButton(tr("detection"));
	mpButtonPlayWhole = new QPushButton();
	mpButtonStop = new QPushButton();
	mpButtonPause = new QPushButton();
	mpButtonPause->hide();

	mpIconPlay = new QIcon(":/icons/play.png");
	mpIconPause = new QIcon(":/icons/pause.png");
	mpIconStop = new QIcon(":/icons/stop.png");
	mpButtonPlayDetection->setIcon(*mpIconPlay);
	mpButtonPlayWhole->setIcon(*mpIconPlay);
	mpButtonStop->setIcon(*mpIconStop);
	mpButtonPause->setIcon(*mpIconPause);
/*	mpButtonPlayDetection->setIcon(style()->standardIcon(QStyle::SP_MediaPlay));
	mpButtonPlayWhole->setIcon(style()->standardIcon(QStyle::SP_MediaPlay));
	mpButtonStop->setIcon(style()->standardIcon(QStyle::SP_MediaStop));
	mpButtonPause->setIcon(style()->standardIcon(QStyle::SP_MediaPause));
*/
	mpButtonPlayDetection->setToolTip(tr("Play detection"));
	mpButtonPlayWhole->setToolTip(tr("Play"));
	mpButtonStop->setToolTip(tr("Stop"));
	mpButtonPause->setToolTip(tr("Pause"));

	connect(&mThread, SIGNAL(AudioFileLengthChanged(unsigned int)), this, SLOT(AudioFileLengthChanged(unsigned int)));
	connect(&mThread, SIGNAL(AudioFilePositionChanged(unsigned int)), this, SLOT(AudioFilePositionChanged(unsigned int)));
	connect(&mThread, SIGNAL(PlayingStarted()), this, SLOT(PlayingStarted()));
	connect(&mThread, SIGNAL(Paused()), this, SLOT(Paused()));
	connect(&mThread, SIGNAL(Stopped()), this, SLOT(Stopped()));
	connect(mpSeekSlider, SIGNAL(sliderMoved(int)), this, SLOT(SliderMoved(int)));
	connect(mpButtonPlayDetection, SIGNAL(clicked()), this, SLOT(PlayDetectionButtonClicked()));
	connect(mpButtonPlayWhole, SIGNAL(clicked()), this, SLOT(PlayWholeButtonClicked()));
	connect(mpButtonPause, SIGNAL(clicked()), this, SLOT(PauseButtonClicked()));
	connect(mpButtonStop, SIGNAL(clicked()), this, SLOT(StopButtonClicked()));

	QHBoxLayout* layoutButtons = new QHBoxLayout;
	layoutButtons->addWidget(mpButtonPlayDetection);
	layoutButtons->addWidget(mpButtonPlayWhole);
	layoutButtons->addWidget(mpButtonPause);
	layoutButtons->addWidget(mpButtonStop);

	QVBoxLayout* layoutMain = new QVBoxLayout;
	layoutMain->addWidget(mpSeekSlider);
	layoutMain->addLayout(layoutButtons);

	setLayout(layoutMain);

	connect(&mThread, SIGNAL(Error(const QString&)), this, SLOT(Error(const QString&)));
}

void MediaPlayer::Error(const QString& msg)
{
	QMessageBox::critical(NULL, tr("MLF Toy"), msg, QMessageBox::Ok, QMessageBox::Ok);
}

void MediaPlayer::PlayDetectionButtonClicked()
{
	mThread.PlayDetection();
}

void MediaPlayer::PlayWholeButtonClicked()
{
	mpButtonPause->show();
	mpButtonPlayWhole->hide();
	mThread.Play();
}

void MediaPlayer::PauseButtonClicked()
{
	mpButtonPause->hide();
	mpButtonPlayWhole->show();
	mThread.Pause();
}

void MediaPlayer::StopButtonClicked()
{
	mThread.Stop();
	mpSeekSlider->setValue(0);
}

void MediaPlayer::AudioFileLengthChanged(unsigned int lengthMs)
{
//	QMessageBox::information(NULL, tr("MLF Toy"), tr("slider length changed to %1").arg(lengthMs), QMessageBox::Ok, QMessageBox::Ok);
	mpSeekSlider->setMaximum(lengthMs);
}

void MediaPlayer::AudioFilePositionChanged(unsigned int posMs)
{
//	QMessageBox::information(NULL, tr("MLF Toy"), tr("audio file position changed to %1").arg(posMs), QMessageBox::Ok, QMessageBox::Ok);
	mpSeekSlider->setValue(posMs);
}

void MediaPlayer::SliderMoved(int pos)
{
//	QMessageBox::information(NULL, tr("MLF Toy"), tr("slider moved to %1").arg(pos), QMessageBox::Ok, QMessageBox::Ok);
	mThread.SeekTo(pos);
}

void MediaPlayer::Stopped()
{
	mpButtonPause->hide();
	mpButtonPlayWhole->show();
	mpSeekSlider->setValue(0);
}

void MediaPlayer::PlayingStarted()
{
}

void MediaPlayer::Paused()
{
}

