#ifndef MEDIAPLAYER_H
#define MEDIAPLAYER_H

#include "mediaplayerthread.h"
#include "dbg.h"
/*
#include <phonon/phononnamespace.h>
#include <phonon/audiooutput.h>
#include <phonon/seekslider.h>
#include <phonon/mediaobject.h>
#include <phonon/volumeslider.h>
#include <phonon/backendcapabilities.h>
*/
#include <QFrame>

class QPushButton;
class QSlider;

class MediaPlayer : public QFrame
{
		Q_OBJECT
	public:
		MediaPlayer(QWidget * parent = NULL);
	
		void SetAudioFilesDirectory(const QString& dir) { mThread.SetAudioFilesDirectory(dir); }
		void SetFilename(const QString& filename) { mThread.SetFilename(filename); }
		void SetLabPath(const QString& path) { mThread.SetLabPath(path); }
		void SetDetectionStartMs(qint64 seekMs) { mThread.SetDetectionStartMs(seekMs); }
		void SetDetectionEndMs(qint64 stopMs) { mThread.SetDetectionEndMs(stopMs); }
		void SetContextMilliseconds(unsigned int contextMs) { mThread.SetContextMilliseconds(contextMs); }
		void SetAudioFileSuffix(QString suffix) { mThread.SetAudioFileSuffix(suffix); }
		void SetIsRawAudio(bool isRaw) { mThread.SetIsRawAudio(isRaw); }
		void SetRawFrequency(int freq) { mThread.SetRawFrequency(freq); }
		void SetRawNumChannels(int n) { mThread.SetRawNumChannels(n); }
		void SetRawFormat(FMOD_SOUND_FORMAT fmt) { mThread.SetRawFormat(fmt); }
		void PlayDetection() { PlayDetectionButtonClicked(); }

	public slots:
//		void SeekableChanged(bool seekable);
//		void StateChanged(Phonon::State newstate, Phonon::State oldstate);
//		void Tick(qint64 time);
		void PlayDetectionButtonClicked();
		void PlayWholeButtonClicked();
		void PauseButtonClicked();
		void StopButtonClicked();
		void AudioFileLengthChanged(unsigned int lengthMs);
		void AudioFilePositionChanged(unsigned int posMs);
		void SliderMoved(int pos);
		void Stopped();
		void PlayingStarted();
		void Paused();
		void Error(const QString& msg);

	private:
		MediaPlayerThread mThread;

		// VISUAL
		QSlider * mpSeekSlider;
		QPushButton * mpButtonPlayDetection;
		QPushButton * mpButtonPlayWhole;
		QPushButton * mpButtonPause;
		QPushButton * mpButtonStop;

		QIcon * mpIconPlay;
		QIcon * mpIconPause;
		QIcon * mpIconStop;
};

#endif

