#ifndef OPENDIALOG_H
#define OPENDIALOG_H

#include "dbg.h"
#include <QDialog>
#include <QString>

class QLineEdit;

class OpenDialog : public QDialog
{
	Q_OBJECT
	public:
		OpenDialog(QWidget * parent = 0, Qt::WindowFlags f = 0);
		QString GetMlfFilename() const;
		QString GetRefMlfFilename() const;
		QString GetWavsPath() const;

	public slots:
		void exec();
		void OpenMlf();
		void OpenRefMlf();
		void OpenWavs();
		void OkClicked();
		void CancelClicked();

	protected:
		void keyPressEvent(QKeyEvent * event);

	private:
		QLineEdit *		mpEditMlf;
		QLineEdit *		mpEditRefMlf;
		QLineEdit *		mpEditWavs;

		QString			mPrevMlf;
		QString			mPrevRefMlf;
		QString			mPrevWavs;
};

#endif

