#ifndef TABLEITEMDELEGATE_H
#define TABLEITEMDELEGATE_H

#include <QItemDelegate>
#include <QFontMetrics>
#include <QModelIndex>
#include <QSize>
#include "mlfsortfilterproxymodel.h"
#include "dbg.h"

class QAbstractItemModel;
class QObject;
class QPainter;
class QSortFilterProxyModel;
class MlfModel;
class QTableView;

static const int ItemSize = 256;

class TableItemDelegate : public QItemDelegate
{
	Q_OBJECT

	public:
		TableItemDelegate(QObject *parent = 0);

		//void drawBackground ( QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index ) const;
		void paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const;
		void SetProxyModel(MlfSortFilterProxyModel* m) { mpProxyModel = m; }
		void SetSourceModel(MlfModel* m) { mpMlfModel = m; }
		void ThresholdChanged(double t) { mThreshold = t; }
		void SetTableView(QTableView * pTableView) { mpTableView = pTableView; }
		void SetColumns(MlfModelData::Columns * pColumns) { mpColumns = pColumns; }
		void SetFixedScoreInterval(bool fixed, double min = 0, double max = 0) { mFixedScoreInterval=fixed; mScoreMin=min; mScoreMax=max; }

	private:
		MlfModel* mpMlfModel;
		MlfSortFilterProxyModel* mpProxyModel;
		QTableView * mpTableView;
		MlfModelData::Columns * mpColumns;
		double mThreshold;

		bool mFixedScoreInterval;
		double mScoreMin;
		double mScoreMax;

		QIcon* mpIconYes;
		QIcon* mpIconNo;
		QIcon* mpIconUndefined;
};

#endif

