#include "tutorialwindow.h"
#include <QtGui>

TutorialWindow::TutorialWindow(QWidget * parent, Qt::WindowFlags f) : QFrame(parent, f)
{
	QPushButton * buttonClose = new QPushButton(tr("Close"));

	QTextBrowser * texteditTut = new QTextBrowser;
	QFile textFile("./tutorial.htm");
	textFile.open(QIODevice::ReadOnly | QIODevice::Text);
	QTextStream textStream(&textFile);
	QString text = textStream.readAll();
	texteditTut->setAcceptRichText(true);
	texteditTut->setText(text);
	texteditTut->setReadOnly(true);

	connect(buttonClose, SIGNAL(clicked()), this, SLOT(close()));

	QVBoxLayout * layoutMain = new QVBoxLayout;
	layoutMain->addWidget(texteditTut);
	layoutMain->addWidget(buttonClose);

	setLayout(layoutMain);

	QRect screen = QApplication::desktop()->screenGeometry();
	int width = screen.width()*0.6;
	int height = screen.height()*0.8;
	int x = (screen.width()-width) / 2;
	int y = (screen.height()-height) / 2;
	setGeometry(x, y, width, height);
//	setWindowModality(Qt::ApplicationModal);
//	setFocusPolicy(Qt::StrongFocus);
}

void TutorialWindow::keyPressEvent(QKeyEvent * event)
{
	switch(event->key())
	{
		case Qt::Key_Escape: close(); break;
	}
}

